%define		PYVER		2.5
%define		__python	python%{PYVER}
%define		PVER		%(echo %{PYVER} | awk -F. '{print$1$2}')
%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

Distribution:	CCux
Packager:	Christian Wasem <wasem@ccux-linux.de>

Name:		mock
Version:	0.9.17
Release:	11
Summary:	Builds packages inside chroots
Group:		Development/Tools
License:	GNU/GPLv2+
Source:		https://fedorahosted.org/mock/attachment/wiki/MockTarballs/%{name}-%{version}.tar.gz
URL:		http://fedoraproject.org/wiki/Projects/Mock
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	noarch

Requires:	python%{PVER}
Requires:	yum
Requires:	tar
Requires:	gzip
Requires:	python%{PVER}-decoratortools
Requires:	usermode
Requires:	createrepo
Requires(pre):	shadow
BuildRequires:	python%{PVER}-devel

Source200:	mock-ccux-1.0-i686.cfg
Source201:	mock-ccux-1.0-x86_64.cfg
Source202:	mock-ccux-site-defaults.cfg
Source203:	mock-build

%define		mock_user	mock
%define		mock_group	mock
%define		mock_home	/home/%{mock_user}

# /home/mock/mock-build-root
%define		mock_build_root		%{mock_home}/%{mock_user}-build-root

# /home/mock/mock-build-cache
%define		mock_build_cache	%{mock_home}/%{mock_user}-build-cache

# /home/mock/mock-build-repo
%define		mock_build_repo		%{mock_home}/%{mock_user}-build-repo

# /home/mock/mock-build-logs
%define		mock_build_logs		%{mock_home}/%{mock_user}-build-logs

# /home/mock/rpmbuild
%define		mock_rpm_home		%{mock_home}/rpmbuild

%description
Mock takes a srpm and builds it in a chroot

%pre
# adding group and user (mock)
/usr/sbin/groupadd %{mock_group} > /dev/null 2>&1 || :
/usr/sbin/useradd -m -g %{mock_group} %{mock_user} -s /bin/bash > /dev/null 2>&1 || :

%post
# update / create local mock repository
/usr/bin/createrepo %{mock_build_repo}/RPMS > /dev/null 2>&1 || :
# make repository writable for mock
chown -R %{mock_user}:%{mock_group} %{mock_build_repo}/RPMS

%postun
# deleting user and group (mock)
/usr/sbin/userdel %{mock_user} > /dev/null 2>&1 || :
/usr/sbin/groupdel %{mock_group} > /dev/null 2>&1 || :

%prep
%setup -q
# buildroot / userdir fix
sed -i "s#/var/lib/mock#/home/%{mock_user}/%{mock_user}-build/root#" py/mock.py
sed -i "s#/var/cache/mock#/home/%{mock_user}/%{mock_user}-build/cache#" py/mock.py

# python fix
FIX=$(find -type f -name "*" -exec grep -I -l -e "^#!/usr/bin/python" -e "^#!/usr/bin/env python" "{}" \; \)
for i in $FIX; do
    sed -i "s,^#!/usr/bin/python,#!/usr/bin/python%{PYVER}," $i
    sed -i "s,^#!/usr/bin/env python,#!/usr/bin/env python%{PYVER}," $i
done

%build
%configure
make

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{mock_build_root}
mkdir -p $RPM_BUILD_ROOT%{mock_build_cache}
ln -s consolehelper $RPM_BUILD_ROOT%_bindir/mock

# examples
mkdir -p $RPM_BUILD_ROOT%_datadir/%{name}-%{version}/examples
mv $RPM_BUILD_ROOT%_sysconfdir/%{name}/*i386.cfg $RPM_BUILD_ROOT%_datadir/%{name}-%{version}/examples
mv $RPM_BUILD_ROOT%_sysconfdir/%{name}/*ppc.cfg $RPM_BUILD_ROOT%_datadir/%{name}-%{version}/examples
mv $RPM_BUILD_ROOT%_sysconfdir/%{name}/*ppc64.cfg $RPM_BUILD_ROOT%_datadir/%{name}-%{version}/examples
mv $RPM_BUILD_ROOT%_sysconfdir/%{name}/*s390x.cfg $RPM_BUILD_ROOT%_datadir/%{name}-%{version}/examples
mv $RPM_BUILD_ROOT%_sysconfdir/%{name}/*sparc.cfg $RPM_BUILD_ROOT%_datadir/%{name}-%{version}/examples
mv $RPM_BUILD_ROOT%_sysconfdir/%{name}/*sparc64.cfg $RPM_BUILD_ROOT%_datadir/%{name}-%{version}/examples
mv $RPM_BUILD_ROOT%_sysconfdir/%{name}/*x86_64.cfg $RPM_BUILD_ROOT%_datadir/%{name}-%{version}/examples

# ccux-config
cp %{SOURCE200} $RPM_BUILD_ROOT%_sysconfdir/mock/ccux-1.0-i686.cfg
cp %{SOURCE201} $RPM_BUILD_ROOT%_sysconfdir/mock/ccux-1.0-x86_64.cfg

# remove defaults
rm -f $RPM_BUILD_ROOT%_sysconfdir/%{name}/site-defaults.cfg

# add cuux defaults
cp %{SOURCE202} $RPM_BUILD_ROOT%_sysconfdir/%{name}/site-defaults.cfg
pushd $RPM_BUILD_ROOT%_sysconfdir/%{name}/
ln -s site-defaults.cfg defaults.cfg
popd

# creating mock-build-repo
mkdir -p $RPM_BUILD_ROOT%{mock_build_repo}/{BUILD,BUILDROOT,RPMS/i686,RPMS/x86_64,RPMS/noarch,SOURCES,SPECS,SRPMS}
# creating rpm home (home/mock/rpmbuild)
mkdir -p $RPM_BUILD_ROOT%{mock_rpm_home}/{BUILD,BUILDROOT,RPMS/i686,RPMS/x86_64,RPMS/noarch,SOURCES,SPECS,SRPMS}
# creating mock-build-logs
mkdir -p $RPM_BUILD_ROOT%{mock_build_logs}

# mock-build
cp %{SOURCE203} $RPM_BUILD_ROOT%{mock_home}/

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
# executables
%_bindir/mock
%attr (0755,mock,mock) %_sbindir/%{name}
# mock-build.sh
%attr (0755,mock,mock) %{mock_home}/mock-build

# python stuff
%{python_sitelib}

# config files
%dir %_sysconfdir/%{name}
%_sysconfdir/%{name}/*.cfg
%_sysconfdir/%{name}/*.ini
%_sysconfdir/pam.d/%{name}
%_sysconfdir/security/console.apps/%{name}

# docs
%_mandir/man1/%{name}.1*
%doc ChangeLog

# examples
%_datadir/%{name}-%{version}/examples

# build dir
%attr(02775,mock,mock) %dir %{mock_build_root}

# cache dir
%attr(02775,mock,mock) %dir %{mock_build_cache}

# mock-build-repo
%attr(0777,mock,mock) %dir %{mock_build_repo}/BUILD
%attr(0777,mock,mock) %dir %{mock_build_repo}/BUILDROOT
%attr(0777,mock,mock) %dir %{mock_build_repo}/RPMS
%attr(0777,mock,mock) %dir %{mock_build_repo}/RPMS/i686
%attr(0777,mock,mock) %dir %{mock_build_repo}/RPMS/noarch
%attr(0777,mock,mock) %dir %{mock_build_repo}/RPMS/x86_64
%attr(0777,mock,mock) %dir %{mock_build_repo}/SOURCES
%attr(0777,mock,mock) %dir %{mock_build_repo}/SPECS
%attr(0777,mock,mock) %dir %{mock_build_repo}/SRPMS

# mock-rpm-home
%attr(0777,mock,mock) %dir %{mock_rpm_home}/BUILD
%attr(0777,mock,mock) %dir %{mock_rpm_home}/BUILDROOT
%attr(0777,mock,mock) %dir %{mock_rpm_home}/RPMS
%attr(0777,mock,mock) %dir %{mock_rpm_home}/RPMS/i686
%attr(0777,mock,mock) %dir %{mock_rpm_home}/RPMS/noarch
%attr(0777,mock,mock) %dir %{mock_rpm_home}/RPMS/x86_64
%attr(0777,mock,mock) %dir %{mock_rpm_home}/SOURCES
%attr(0777,mock,mock) %dir %{mock_rpm_home}/SPECS
%attr(0777,mock,mock) %dir %{mock_rpm_home}/SRPMS

# mock-build-logs
%attr(0777,mock,mock) %dir %{mock_build_logs}

%changelog
* Sat Nov 07 2009 Christian Wasem <wasem@ccux-linux.de> 0.9.17-11
- mofified mock-build script
* Sat Nov 07 2009 Christian Wasem <wasem@ccux-linux.de> 0.9.17-10
- make mock-build-repo writable for mock user
* Sat Nov 07 2009 Christian Wasem <wasem@ccux-linux.de> 0.9.17-9
- added mock-build script (lies in home dir)
* Fri Nov 06 2009 Christian Wasem <wasem@ccux-linux.de> 0.9.17-8
- changed mock-rpm-repo to /home/mock/mock-build-repo
- added mock-build-logs
* Fri Nov 06 2009 Christian Wasem <wasem@ccux-linux.de> 0.9.17-7
- added rebuild-srpm script, fix createrepo path
- added ccux-buildsystem metapackage in site-defaults.cfg
* Thu Nov 05 2009 Christian Wasem <wasem@ccux-linux.de> 0.9.17-6
- make createrpo silent during install
* Thu Nov 05 2009 Christian Wasem <wasem@ccux-linux.de> 0.9.17-5
- changed defaults in configs
* Wed Nov 04 2009 Christian Wasem <wasem@ccux-linux.de> 0.9.17-4
- changed default dir attribs and user settings with useradd
* Wed Nov 04 2009 Christian Wasem <wasem@ccux-linux.de> 0.9.17-3
- changed default settings in sources
* Tue Nov 02 2009 Christian Wasem <wasem@ccux-linux.de> 0.9.17-2
- added ccux related sources
* Sat Oct 31 2009 Christian Wasem <wasem@ccux-linux.de> 0.9.17-1
- Initial CCux Release
